import { Client, FormData } from "undici";
import { IApiResult } from "./types/IUpdate";
export declare class ApiError extends Error {
    code: number;
    method: string;
    params: string;
}
export declare type SupportedParamsBody = Record<string, unknown> | FormData;
export declare class Api {
    private readonly token;
    private readonly log;
    private readonly baseUrl;
    clientOptions: Client.Options;
    private readonly client;
    constructor(token: string, client?: Client);
    /**
     * Call method with params as a formdata
     */
    upload<TResult>(method: string, params: SupportedParamsBody): Promise<IApiResult<TResult>>;
    callMethod<TResult>(method: string, params: SupportedParamsBody): Promise<IApiResult<TResult>>;
    private parseParams;
    private handleTelegramApiError;
}
