"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Conversation = void 0;
const utils_1 = require("../utils");
const ConversationAnswer_1 = require("./ConversationAnswer");
const ConversationOptions_1 = require("./ConversationOptions");
class Conversation {
    constructor() {
        this.middleware = new utils_1.Middleware();
    }
    handle(ctx) {
        let token = new utils_1.MiddlewareToken();
        return this.middleware.handle(ctx, token);
    }
    waitAnswer(ctx, options) {
        return new Promise(resolve => {
            let segment = this.middleware.add(async (upd, next) => {
                if (ctx.chat.id !== upd.chat.id) {
                    next();
                    return;
                }
                let match = (options === null || options === void 0 ? void 0 : options.condition) instanceof RegExp
                    ? ctx.text.match(options.condition)
                    : [];
                if (options.condition &&
                    !(0, ConversationOptions_1.checkCondition)(upd, options.condition)) {
                    if (options === null || options === void 0 ? void 0 : options.conditionFallback) {
                        await options.conditionFallback(ctx);
                    }
                    return next();
                }
                this.middleware.remove(segment);
                resolve(new ConversationAnswer_1.ConversationAnswer(ctx, match));
            });
        });
    }
}
exports.Conversation = Conversation;
