"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Button = exports.InlineButton = exports.BaseButton = void 0;
class BaseButton {
    constructor(text) {
        this.text = text;
    }
}
exports.BaseButton = BaseButton;
class InlineButton extends BaseButton {
    constructor(params) {
        super(params.text);
        for (let [key, val] of Object.entries(params)) {
            this[key] = val;
        }
    }
    toObject() {
        let btn = {
            text: this.text,
            callback_data: this.payload,
            url: this.url,
            switch_inline_query: this.switchQuery,
            switch_inline_query_current_chat: this.switchCurrentChatQuery,
        };
        return Object.entries(btn)
            .filter(([_, v]) => v != null)
            .reduce((acc, [key, val]) => (Object.assign({ [key]: val }, acc)), {});
    }
}
exports.InlineButton = InlineButton;
class Button extends BaseButton {
    constructor(text, requestType) {
        super(text);
        this.requestType = requestType;
    }
    toObject() {
        let btn = {
            text: this.text,
        };
        let type = this.requestType;
        if (type === "contact")
            btn["request_contact"] = true;
        else if (type === "location")
            btn["request_location"] = true;
        else if (type === "poll_regular")
            btn["request_poll"] = { type: "regular" };
        else if (type === "poll_quiz")
            btn["request_poll"] = { type: "quiz" };
        return btn;
    }
}
exports.Button = Button;
