export declare type MiddlewareFn<T> = (arg: T, next: (nextArg?: T) => void) => any;
export interface MiddlewareSegment<T> {
    id: string;
    fn: MiddlewareFn<T>;
}
export declare class MiddlewareToken {
    private passingState;
    next(): void;
    complete(fn: () => Promise<any>): Promise<void>;
}
export declare class Middleware<T> {
    private segments;
    handle(arg: T, token: MiddlewareToken): Promise<void>;
    add(fn: MiddlewareFn<T>): MiddlewareSegment<T>;
    remove(segment: MiddlewareSegment<T>): boolean;
}
